/* Generated by wayland-scanner 1.23.1 */

#ifndef TEXT_INPUT_X11_UNSTABLE_V1_SERVER_PROTOCOL_H
#define TEXT_INPUT_X11_UNSTABLE_V1_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_text_input_x11_unstable_v1 The text_input_x11_unstable_v1 protocol
 * @section page_ifaces_text_input_x11_unstable_v1 Interfaces
 * - @subpage page_iface_zcr_text_input_x11_v1 - Extension support for using text_input with X11 apps
 * @section page_copyright_text_input_x11_unstable_v1 Copyright
 * <pre>
 *
 * Copyright 2022 The ChromiumOS Authors
 * Use of this source code is governed by a BSD-style license that can be
 * found in the LICENSE file.
 * </pre>
 */
struct wl_seat;
struct zcr_text_input_x11_v1;
struct zwp_text_input_v1;

#ifndef ZCR_TEXT_INPUT_X11_V1_INTERFACE
#define ZCR_TEXT_INPUT_X11_V1_INTERFACE
/**
 * @page page_iface_zcr_text_input_x11_v1 zcr_text_input_x11_v1
 * @section page_iface_zcr_text_input_x11_v1_desc Description
 *
 * Adds functionality for X11 apps running on Xwayland to connect to the
 * Wayland compositor and receive text_input support.
 *
 * TODO(b/295265862): Remove this protocol and its implementation some time
 * after M122. It has been replaced by zcr_text_input_crostini_v1 since M118,
 * but users can sometimes end up on older version of cros_im.
 * @section page_iface_zcr_text_input_x11_v1_api API
 * See @ref iface_zcr_text_input_x11_v1.
 */
/**
 * @defgroup iface_zcr_text_input_x11_v1 The zcr_text_input_x11_v1 interface
 *
 * Adds functionality for X11 apps running on Xwayland to connect to the
 * Wayland compositor and receive text_input support.
 *
 * TODO(b/295265862): Remove this protocol and its implementation some time
 * after M122. It has been replaced by zcr_text_input_crostini_v1 since M118,
 * but users can sometimes end up on older version of cros_im.
 */
extern const struct wl_interface zcr_text_input_x11_v1_interface;
#endif

/**
 * @ingroup iface_zcr_text_input_x11_v1
 * @struct zcr_text_input_x11_v1_interface
 */
struct zcr_text_input_x11_v1_interface {
	/**
	 * request activation
	 *
	 * Calls text_input::activate with the X11 window id converted to
	 * the matching wl_surface.
	 */
	void (*activate)(struct wl_client *client,
			 struct wl_resource *resource,
			 struct wl_resource *text_input,
			 struct wl_resource *seat,
			 uint32_t x11_window_id);
};


/**
 * @ingroup iface_zcr_text_input_x11_v1
 */
#define ZCR_TEXT_INPUT_X11_V1_ACTIVATE_SINCE_VERSION 1

#ifdef  __cplusplus
}
#endif

#endif
